#
# Conditional build:
%bcond_without  tests   # unit/functional tests
%bcond_without  python2 # CPython 2.x module
%bcond_without  python3 # CPython 3.x module
#
%define		module	ply
Summary:	Python 2 Lex-Yacc
Summary(pl.UTF-8):	lex i yacc dla Pythona 2
Name:		python-%{module}
# note: keep 3.x here for python2 support; for 4+ create python3- .spec instead
Version:	3.11
Release:	10
License:	BSD
Group:		Libraries/Python
Source0:	http://www.dabeaz.com/ply/ply-%{version}.tar.gz
# Source0-md5:	6465f602e656455affcd7c5734c638f8
Patch0:		python3.12-tests.patch
URL:		http://www.dabeaz.com/ply/
BuildRequires:	rpmbuild(macros) >= 1.714
%if %{with python2}
BuildRequires:	python >= 1:2.7
%if %{with tests}
BuildRequires:	python-setuptools
BuildRequires:	python-six
%endif
%endif
%if %{with python3}
BuildRequires:	python3 >= 1:3.2
%if %{with tests}
BuildRequires:	python3-setuptools
BuildRequires:	python3-six
%endif
%endif
Requires:	python-modules >= 1:2.7
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
PLY is yet another implementation of lex and yacc for Python. Although
several other parsing tools are available for Python, there are
several reasons why you might want to take a look at PLY:
- It uses LR-parsing which is reasonably efficient and well suited for
  larger grammars.
- PLY provides most of the standard lex/yacc features including
  support for empty productions, precedence rules, error recovery, and
  support for ambiguous grammars.
- PLY is extremely easy to use and provides very extensive error
  checking.

%description -l pl.UTF-8
PLY to kolejna implementacja narzędzi lex i yacc dla Pythona. Mimo iż
istnieje kilka innych analizatorów dla Pythona, to istnieje kilka
powodów, dla których można zainteresować się PLY:
- Używa on analizy LR, która jest w miarę wydajna i dość dobra dla
  większych gramatyk.
- Udostępnia większość możliwości standardowych lex/yacc, w tym
  obsługę pustych produkcji, reguł poprzedzania, rekompensowania błędów
  oraz obsługę niejednoznacznych gramatyk.
- Jest niezwykle łatwy w użyciu oraz zapewnia rozległą kontrolę
  błędów.

%package -n python3-%{module}
Summary:	Python 3 Lex-Yacc
Summary(pl.UTF-8):	lex i yacc dla Pythona 3
Group:		Libraries/Python
Requires:	python3-modules >= 1:3.2

%description -n python3-%{module}
PLY is yet another implementation of lex and yacc for Python. Although
several other parsing tools are available for Python, there are
several reasons why you might want to take a look at PLY:
- It uses LR-parsing which is reasonably efficient and well suited for
  larger grammars.
- PLY provides most of the standard lex/yacc features including
  support for empty productions, precedence rules, error recovery, and
  support for ambiguous grammars.
- PLY is extremely easy to use and provides very extensive error
  checking.

%description -n python3-%{module} -l pl.UTF-8
PLY to kolejna implementacja narzędzi lex i yacc dla Pythona. Mimo iż
istnieje kilka innych analizatorów dla Pythona, to istnieje kilka
powodów, dla których można zainteresować się PLY:
- Używa on analizy LR, która jest w miarę wydajna i dość dobra dla
  większych gramatyk.
- Udostępnia większość możliwości standardowych lex/yacc, w tym
  obsługę pustych produkcji, reguł poprzedzania, rekompensowania błędów
  oraz obsługę niejednoznacznych gramatyk.
- Jest niezwykle łatwy w użyciu oraz zapewnia rozległą kontrolę
  błędów.

%package examples
Summary:	Python Lex-Yacc - examples
Summary(pl.UTF-8):	lex i yacc dla Pythona - przykłady
Group:		Development/Languages/Python

%description examples
Python Lex-Yacc - examples.

%description examples -l pl.UTF-8
lex i yacc dla Pythona - przykłady.

%prep
%setup -q -n %{module}-%{version}
%patch -P0 -p1

%{__sed} -i -e '1s,/usr/bin/env python,%{__python},' \
	example/{,new}classcalc/calc.py

%build
%if %{with python2}
%py_build

%if %{with tests}
cd test
for t in testlex.py testyacc.py testcpp.py ; do
PYTHONPATH=$(pwd)/.. \
%{__python} "$t"
done
./cleanup.sh
cd ..
%endif
%endif

%if %{with python3}
%py3_build

%if %{with tests}
cd test
for t in testlex.py testyacc.py testcpp.py ; do
PYTHONPATH=$(pwd)/.. \
%{__python3} "$t"
done
./cleanup.sh
cd ..
%endif
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}

%if %{with python2}
%py_install

%py_postclean
%endif

%if %{with python3}
%py3_install
%endif

cp -Rf example/* $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}

%clean
rm -rf $RPM_BUILD_ROOT

%if %{with python2}
%files
%defattr(644,root,root,755)
%doc ANNOUNCE CHANGES README.md TODO doc/*.html
%dir %{py_sitescriptdir}/ply
%{py_sitescriptdir}/ply/*.py[co]
%{py_sitescriptdir}/ply-%{version}-py*.egg-info
%endif

%if %{with python3}
%files -n python3-%{module}
%defattr(644,root,root,755)
%doc ANNOUNCE CHANGES README.md TODO doc/*.html
%{py3_sitescriptdir}/ply
%{py3_sitescriptdir}/ply-%{version}-py*.egg-info
%endif

%files examples
%defattr(644,root,root,755)
%{_examplesdir}/%{name}-%{version}
%changelog
* Tue Mar 25 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/python-ply.git;a=log;h=master

* Tue Mar 25 2025 Jan Palus <atler@pld-linux.org> 519d3bf
- restore tests compatibility with python >= 3.12; rel 10

* Tue Mar 11 2025 Jan Rękorajski <baggins@pld-linux.org> b93353c
- doc/test rebuild for python 3.13

* Mon Mar 10 2025 Jan Rękorajski <baggins@pld-linux.org> ab2ef8e
- python 3.13 rebuild

* Thu Apr 25 2024 Marcin Krol <hawk@tld-linux.org> 2c602d0
- fix python2 condition

* Wed Mar 30 2022 Jan Rękorajski <baggins@pld-linux.org> 0d83f74
- rebuild with tests and docs

* Sat Mar 26 2022 Jakub Bogusz <qboosh@pld-linux.org> 9dd4b9e
- actually run tests, dropped Obsoletes for package which never existed

* Sat Mar 26 2022 Jan Rękorajski <baggins@pld-linux.org> dfe6c10
- rebuild with python 3.10

* Fri Mar 25 2022 Jan Rękorajski <baggins@pld-linux.org> 657e90c
- rebuild with python 3.10

* Tue Mar 02 2021 Jan Rękorajski <baggins@pld-linux.org> 40fdf7d
- release 4 (by relup.sh)

* Mon Mar 01 2021 Jan Palus <atler@pld-linux.org> 65d4aff
- fix shebangs; rel 3

* Mon Mar 01 2021 Jan Palus <atler@pld-linux.org> defeecf
- move %py*_build from %prep to %build

* Fri Jun 05 2020 Jakub Bogusz <qboosh@pld-linux.org> 06de102
- note on version 4 dropping python2 support; use python3-*.spec namespace

* Mon Oct 28 2019 Jan Rękorajski <baggins@pld-linux.org> 58b9edf
- rebuild with python 3.8
- release 2 (by relup.sh)

* Mon Jul 23 2018 Jakub Bogusz <qboosh@pld-linux.org> e2e08d8
- updated to 3.11

* Sun Jul 01 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 2072e8b
- release 2 (by relup.sh)

* Tue Nov 07 2017 Marcin Krol <hawk@tld-linux.org> 96549a9
- updated to 3.10

* Thu Jan 12 2017 Jakub Bogusz <qboosh@pld-linux.org> 820e97e
- test target BRs setuptools

* Thu Dec 29 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> 1486571
- python 3.6
- release 2 (by relup.sh)

* Sat Oct 15 2016 Jakub Bogusz <qboosh@pld-linux.org> 4633208
- updated to 3.9

* Fri Jul 29 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> d10e53f
- up to 3.8; add python3 module

